package sample3;

import java.net.URL;

import com.google.gdata.client.spreadsheet.CellQuery;
import com.google.gdata.client.spreadsheet.SpreadsheetService;
import com.google.gdata.data.Link;
import com.google.gdata.data.batch.BatchOperationType;
import com.google.gdata.data.batch.BatchUtils;
import com.google.gdata.data.spreadsheet.CellEntry;
import com.google.gdata.data.spreadsheet.CellFeed;
import com.google.gdata.data.spreadsheet.SpreadsheetEntry;
import com.google.gdata.data.spreadsheet.WorksheetEntry;

public class BatchUpdate {
	public static void main(String[] args) throws Exception {
		// 操作対象のワークシートを取得する。
		SpreadsheetService service = SpreadsheetUtil.getSpreadsheetService();
		SpreadsheetEntry spreadsheetEntry = SpreadsheetUtil.findSpreadsheet(
				service, "セル単位でのデータ操作");
		WorksheetEntry worksheetEntry = spreadsheetEntry.getDefaultWorksheet();

		// 更新対象のセルを取得
		CellQuery cellQuery = new CellQuery(worksheetEntry.getCellFeedUrl());
		cellQuery.setRange("A5:C5");
		cellQuery.setReturnEmpty(true); // 空セルも返すようにする
		CellFeed cellFeed = service.query(cellQuery, CellFeed.class);

		// 更新
		CellFeed batchFeed = new CellFeed();
		CellEntry cellEntry;
		// A3
		cellEntry = cellFeed.getEntries().get(0);
		cellEntry.changeInputValueLocal("3");
		BatchUtils.setBatchId(cellEntry, cellEntry.getTitle().getPlainText());
		BatchUtils.setBatchOperationType(cellEntry, BatchOperationType.UPDATE);
		batchFeed.getEntries().add(cellEntry);
		// B3
		cellEntry = cellFeed.getEntries().get(1);
		cellEntry.changeInputValueLocal("4");
		BatchUtils.setBatchId(cellEntry, cellEntry.getTitle().getPlainText());
		BatchUtils.setBatchOperationType(cellEntry, BatchOperationType.UPDATE);
		batchFeed.getEntries().add(cellEntry);
		// C3
		cellEntry = cellFeed.getEntries().get(2);
		cellEntry.changeInputValueLocal("=SUM(A5,B5)");
		BatchUtils.setBatchId(cellEntry, cellEntry.getTitle().getPlainText());
		BatchUtils.setBatchOperationType(cellEntry, BatchOperationType.UPDATE);
		batchFeed.getEntries().add(cellEntry);
		// バッチリクエスト発行
		Link batchLink = cellFeed.getLink(Link.Rel.FEED_BATCH, Link.Type.ATOM);
		service.getRequestFactory().setHeader("If-Match", "*");
		service.batch(new URL(batchLink.getHref()), batchFeed);
		service.getRequestFactory().setHeader("If-Match", null);

		System.out.println("セルの更新が完了しました。");
	}
}
