package sample3;

import com.google.gdata.client.spreadsheet.CellQuery;
import com.google.gdata.client.spreadsheet.SpreadsheetService;
import com.google.gdata.data.spreadsheet.CellEntry;
import com.google.gdata.data.spreadsheet.CellFeed;
import com.google.gdata.data.spreadsheet.SpreadsheetEntry;
import com.google.gdata.data.spreadsheet.WorksheetEntry;

public class CellUpdate {
	public static void main(String[] args) throws Exception {
		// 操作対象のワークシートを取得する。
		SpreadsheetService service = SpreadsheetUtil.getSpreadsheetService();
		SpreadsheetEntry spreadsheetEntry = SpreadsheetUtil.findSpreadsheet(
				service, "セル単位でのデータ操作");
		WorksheetEntry worksheetEntry = spreadsheetEntry.getDefaultWorksheet();

		// 更新対象のセルを取得
		CellQuery cellQuery = new CellQuery(worksheetEntry.getCellFeedUrl());
		cellQuery.setRange("A1:C1");
		cellQuery.setReturnEmpty(true); // 空セルも返すようにする
		CellFeed cellFeed = service.query(cellQuery, CellFeed.class);

		// 更新
		CellEntry cellEntry;
		// A1
		cellEntry = cellFeed.getEntries().get(0);
		System.out.println(cellEntry.getTitle().getPlainText());
		cellEntry.changeInputValueLocal("3");
		cellEntry.update();
		// B1
		cellEntry = cellFeed.getEntries().get(1);
		System.out.println(cellEntry.getTitle().getPlainText());
		cellEntry.changeInputValueLocal("4");
		cellEntry.update();
		// C1
		cellEntry = cellFeed.getEntries().get(2);
		System.out.println(cellEntry.getTitle().getPlainText());
		cellEntry.changeInputValueLocal("=SUM(A1,B1)");
		cellEntry.update();

		System.out.println("セルの更新が完了しました。");
	}
}
