package sample3;

import com.google.gdata.client.spreadsheet.CellQuery;
import com.google.gdata.client.spreadsheet.SpreadsheetService;
import com.google.gdata.data.spreadsheet.CellEntry;
import com.google.gdata.data.spreadsheet.CellFeed;
import com.google.gdata.data.spreadsheet.SpreadsheetEntry;
import com.google.gdata.data.spreadsheet.WorksheetEntry;

public class ForceUpdate {
	public static void main(String[] args) throws Exception {
		// 操作対象のワークシートを取得する。
		SpreadsheetService service = SpreadsheetUtil.getSpreadsheetService();
		SpreadsheetEntry spreadsheetEntry = SpreadsheetUtil.findSpreadsheet(
				service, "セル単位でのデータ操作");
		WorksheetEntry worksheetEntry = spreadsheetEntry.getDefaultWorksheet();

		// 更新対象のセルを取得
		CellQuery cellQuery = new CellQuery(worksheetEntry.getCellFeedUrl());
		cellQuery.setRange("B3");
		cellQuery.setReturnEmpty(true); // 空セルも返すようにする
		CellFeed cellFeed = service.query(cellQuery, CellFeed.class);
		CellEntry cellEntry = cellFeed.getEntries().get(0);

		// 1回目
		System.out.println("1回目のETag:" + cellEntry.getEtag());
		cellEntry.changeInputValueLocal("1回目");
		cellEntry = cellEntry.update();

		// 2回目
		System.out.println("2回目のETag:" + cellEntry.getEtag());
		cellEntry.changeInputValueLocal("2回目");
		cellEntry.update();

		// 3回目
		service.getRequestFactory().setHeader("If-Match", "*");
		cellEntry.setEtag(null);
		System.out.println("3回目のETag:" + cellEntry.getEtag());
		cellEntry.changeInputValueLocal("3回目");
		cellEntry.update();
		service.getRequestFactory().setHeader("If-Match", null);
	}
}
