package sample3;

import com.google.gdata.client.spreadsheet.CellQuery;
import com.google.gdata.client.spreadsheet.SpreadsheetService;
import com.google.gdata.data.spreadsheet.CellEntry;
import com.google.gdata.data.spreadsheet.CellFeed;
import com.google.gdata.data.spreadsheet.SpreadsheetEntry;
import com.google.gdata.data.spreadsheet.WorksheetEntry;

public class MassUpdateByNormal {
	public static void main(String[] args) throws Exception {
		// 操作対象のワークシートを取得する。
		SpreadsheetService service = SpreadsheetUtil.getSpreadsheetService();
		SpreadsheetEntry spreadsheetEntry = SpreadsheetUtil.findSpreadsheet(
				service, "セル単位でのデータ操作");
		WorksheetEntry worksheetEntry = spreadsheetEntry.getDefaultWorksheet();

		// 更新対象のセルを取得
		CellQuery cellQuery = new CellQuery(worksheetEntry.getCellFeedUrl());
		cellQuery.setRange("A10:E20");
		cellQuery.setReturnEmpty(true); // 空セルも返すようにする
		CellFeed cellFeed = service.query(cellQuery, CellFeed.class);

		// 更新
		long start = System.currentTimeMillis();
		for (int i = 0; i < 30; i++) {
			CellEntry cellEntry = cellFeed.getEntries().get(i);
			cellEntry.changeInputValueLocal("Normal" + i);
			cellEntry.update();
		}
		long end = System.currentTimeMillis();
		System.out.println("処理時間は" + (end - start) + "ミリ秒でした。");
	}
}
