package sample3;

import java.io.IOException;

import com.google.gdata.client.spreadsheet.FeedURLFactory;
import com.google.gdata.client.spreadsheet.SpreadsheetQuery;
import com.google.gdata.client.spreadsheet.SpreadsheetService;
import com.google.gdata.data.spreadsheet.SpreadsheetEntry;
import com.google.gdata.data.spreadsheet.SpreadsheetFeed;
import com.google.gdata.util.AuthenticationException;
import com.google.gdata.util.ServiceException;

public class SpreadsheetUtil {

	public static SpreadsheetService getSpreadsheetService()
			throws AuthenticationException {
		// このアプリケーションの名称。任意の名前を設定する。
		String applicationName = "topgate.co.jp-sample-1";
		// GoogleAppsもしくはGoogleアカウントのメールアドレスとパスワードを設定する。
		String username = "";
		String password = "";
		// Spreadsheetsサービスへの認証を行う。
		SpreadsheetService service = new SpreadsheetService(applicationName);
		service.setUserCredentials(username, password);
		return service;
	}

	public static SpreadsheetEntry findSpreadsheet(SpreadsheetService service,
			String title) throws IOException, ServiceException {
		// 検索対象のスプレッドシートを取得する。
		FeedURLFactory urlFactory = FeedURLFactory.getDefault();
		SpreadsheetQuery spreadsheetQuery = new SpreadsheetQuery(urlFactory
				.getSpreadsheetsFeedUrl());
		spreadsheetQuery.setTitleQuery(title); // 検索対象のスプレッドシート名を指定している。
		SpreadsheetFeed spreadsheetFeed = service.query(spreadsheetQuery,
				SpreadsheetFeed.class);
		SpreadsheetEntry spreadsheetEntry = spreadsheetFeed.getEntries().get(0);
		return spreadsheetEntry;
	}

}
